<?php
// (A) LOAD LIBRARIES
// composer require react/socket
require "2-mail-lib.php";
require "vendor/autoload.php";

// (B) FLAG
$sending = false; // is currently sending emails
$result = null; // last run result

// (C) CREATE ENDPOINT - "PING TO RUN"
$socket = new React\Socket\SocketServer(isset($argv[1]) ? $argv[1] : MQ_POINT, [
  "tls" => ["local_cert" => isset($argv[2]) ? $argv[2] : (__DIR__ . "/localhost.pem")]
]);
$socket->on("connection", function (React\Socket\ConnectionInterface $connection) {
  $connection->close();
  global $sending, $result, $_MQ;
  if (!$sending) {
    $sending = true;
    do {
      $result = $_MQ->pop();
      if ($result==null) { $sending = false; }
      usleep(200000); // 0.2 seconds pause
    } while ($result != null);
  }
});
echo "Listening on " . $socket->getAddress() . PHP_EOL;